<?php

define('MOODTHINGY_CSS_DEFAULT', MOODTHINGY_PLUGIN_DIR . '/css/style-custom.css');
define('MOODTHINGY_CSS_FILE', WP_CONTENT_DIR . '/uploads/moodthingy-custom.css');
define('MOODTHINGY_CSS_URI', WP_CONTENT_URL . '/uploads/moodthingy-custom.css');


function moodthingy_wp_menu() {
    // wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js');

	add_dashboard_page('MoodThingy Dashboard', 'MoodThingy Stats', 'manage_options', 'moodthingy', 'moodthingy_dashboard_page');
	add_options_page('MoodThingy Options', 'MoodThingy', 'manage_options', 'moodthingy', 'moodthingy_settings_page');
}

// Add settings link on plugin page
function moodthingy_settings_link($links) { 
  $settings_link = '<a href="options-general.php?page=moodthingy">Settings</a>';
  array_unshift($links, $settings_link); 
  return $links; 
}

function moodthingy_settings_page() {
	global $wpdb;
	global $moods;
	global $moodthingy_server;
	global $use_centralized_site;
	
	$hidden_field_name = 'moodthingy_submit_hidden';
	$options = get_option('moodthingy_wp_options');

	// http://codex.wordpress.org/Adding_Administration_Menus
	
	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	} ?>
	<style>
	.selected { font-weight:bold; color:#000; text-decoration: none; }
	.content { display:none; }
	#settings { display:block; }
	#apikey, #apiname { padding: 5px; width: 200px; }
	</style>
	<script type="text/javascript">

	<?php if ( $use_centralized_site ) : ?>
	jQuery(document).ready(function(){
	
		if ( jQuery('#validkey').val()=='1' ) {
			jQuery('#apiverifyresult').html('Your Website ID and API key have been verified. Your widget will now appear on your blog posts!');
		} else {
			jQuery('#apiverifyresult').html('<span style="color:red;">Your Website ID and/or API key don\'t match our records. Your widget will not appear until it does. Try copying & pasting them again.</span>');
		}
	
		function verify( submit_form_afterward ) {
			// http://stackoverflow.com/questions/1388018/jquery-attaching-an-event-to-multiple-elements-at-one-go
			var jApikey = jQuery("#apikey");
			var jApiname = jQuery("#apiname");
			var jObj = jApikey.add(jApiname);

			var n = jApiname.val();
			n = jQuery.trim(n);
			var k = jApikey.val();
			k = jQuery.trim(k);
			// console.log(n,k);
			jQuery.ajax({
				url: '<?php echo $moodthingy_server; ?>/api/websites/verify/' + n + '/' + k,
				dataType: 'jsonp',
				type: 'get',
				success: function(j) {
					if (j.stat == 'ok') {
						jQuery('#apiverifyresult').html('Your Website ID and API key have been verified. Your widget will appear on your blog posts, but don\'t forget to save your changes!');
						jQuery('#validkey').val('1');
					} else {
						jQuery('#apiverifyresult').html('<span style="color:red;">Your Website ID and/or API key don\'t match our records. Your widget will not appear until it does. Try copying & pasting them again.</span>');
						jQuery('#validkey').val('');
					}
					
					if (submit_form_afterward) jQuery('form#options').submit();
					
				}
			});
		}
	
		var jApikey = jQuery("#apikey");
		var jApiname = jQuery("#apiname");
		var jObj = jApikey.add(jApiname);
					
		jQuery('form#options p.submit input.button-primary').click( function(){ verify(true); } );
		jObj.blur( function(){ verify(); } );
		
	});	
	<?php endif; ?>

	jQuery(document).ready(function(){
	
	
		if ( window.location.hash ) {
			var str = window.location.hash.split('#')[1];
			// console.log(str);

			jQuery('a[rel="' + str + '"]').addClass("nav-tab-active").siblings().removeClass("nav-tab-active");
			jQuery(".content:visible").css("display","none");
			jQuery("#"+str).css("display", "block");
		}
	
		jQuery(".nav-tab").click(function(){
			
			var activeTab = jQuery(this).attr("rel");
			if ( typeof(activeTab) != 'undefined' ) {
				jQuery(this).addClass("nav-tab-active").siblings().removeClass("nav-tab-active");
				jQuery(".content:visible").fadeOut("fast", function(){
					jQuery("#"+activeTab).slideDown("fast");
				});
				
				return false;
			}

		});	

		if (jQuery('input[name="bypasscss"]').is(':checked')) { jQuery('#csswrapper').hide(); } 
		
		jQuery('input[name="bypasscss"]').click(function(){
			// jQuery('#cssbox').prop("disabled", this.checked);
			jQuery('#csswrapper').css("display", (this.checked) ? "none" : "block");
		});
					
	});	

	</script>

	<?php 
	
		if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
		
			if ( trim($_POST[ 'cleardata' ] == 'DELETE') ) {
				moodthingy_reset_moods();		
			} else {
		
				$options['showsparkbar'] 			= $_POST[ 'showsparkbar' ];
				$options['sortmoods']				= $_POST[ 'sortmoods' ];
				$options['showinpostsondefault'] 	= $_POST[ 'showinpostsondefault' ];
				$options['bypasscss']				= $_POST[ 'bypasscss' ];				
				$options['showtweetfollowup'] 		= ( $_POST[ 'showtweetfollowup' ] ) ? $_POST[ 'showtweetfollowup' ] : 'off' ;
							
				$options['apikey'] 					= $_POST[ 'apikey' ];
				$options['apiname'] 				= $_POST[ 'apiname' ];
				$options['validkey'] 				= $_POST[ 'validkey' ];

				@file_put_contents(MOODTHINGY_CSS_FILE, strip_tags( $_POST[ 'cssbox' ] ) );
				
				if ($options['showinpostsondefault'] == 'on') {
					add_filter('the_content', 'add_moodthingy_widget_to_posts');
				}
				
				update_option('moodthingy_wp_options', $options);
				echo '<div class="updated"><p><strong>Settings Saved.</strong></p></div>';

			}
		}

	?>	

	<div class="wrap">

		<h2 class="nav-tab-wrapper">
			MoodThingy
			
			<a class="nav-tab" href="<?php echo admin_url('index.php?page=moodthingy'); ?>">Stats</a>
			<a class="nav-tab nav-tab-active" rel="settings" href="#">Settings</a>
			<a class="nav-tab" rel="customize" href="#">Customization</a>
			<a class="nav-tab" rel="faq" href="#">FAQ</a>
		</h2>
		<div class="container">	
			<div class="content" id="settings">
				<form id="options" method="post">
				<h3 style="clear:both;">Plugin Settings</h3>
			
				<?php if ( $use_centralized_site ) : ?>
				<p>If you have an account on <a href="http://www.moodthingy.com/" target="_blank">MoodThingy.com</a>, register your blog on the website to see stats and other useful information!</p>
					<p>
					<label for="apiname">Your Website ID from moodthingy.com</label><br>
					<input id="apiname" name="apiname" size="13" type="input" value="<?php echo $options['apiname']; ?>">
					</p>
					
					<p>
					<label for="apikey">Your API Key from moodthingy.com</label><br>
					<input id="apikey" name="apikey" type="input" value="<?php echo $options['apikey']; ?>">
					</p>
					
					<div id="apiverifyresult"></div>
				<?php endif; ?>
				
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">Sparkbars</th>
							<td><input type="checkbox" id="showsparkbar" name="showsparkbar" <?php if ( $options["showsparkbar"]=='on' ) { echo 'checked="true"'; } ?>> <label for="showsparkbar">Show a sparkline (graphical bar graph) above moods.</label></td>
						</tr>

						<tr valign="top">
							<th scope="row">Sorting</th>
							<td><input type="checkbox" id="sortmoods" name="sortmoods" <?php if ( $options["sortmoods"]=='on' ) { echo 'checked="true"'; } ?>> <label for="sortmoods">Automatically sort the moods by popularity.</label></td>
						</tr>

						<tr valign="top">
							<th scope="row">Automatic Display</th>
							<td><input type="checkbox" id="showinpostsondefault" name="showinpostsondefault" <?php if ( $options["showinpostsondefault"]=='on' ) { echo 'checked="true"'; } ?>> <label for="showinpostsondefault">Automatically display the MoodThingy widget at the end of each blog post.</label> <p class="description">If this is unchecked, you will need to use the print_moodthingy_widget() PHP function in your templates or use the [moodthingy] shortcode. Check the FAQ for more information.</p></td>
						</tr>
			
						<tr valign="top">
							<th scope="row">Twitter</th>
							<td><input type="checkbox" id="showtweetfollowup" name="showtweetfollowup" <?php if ( $options["showtweetfollowup"]=='on' ) { echo 'checked="true"'; } ?>> <label for="showtweetfollowup">Allow people to tweet after voting.</label></td>
						</tr>
			
					</tbody>
				</table>
				
				
				<h3>Plugin Data</h3>
				
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">Clear All Mood Data</th>
							<td><input type="textbox" id="cleardata" name="cleardata"> 
							
							<p>IMPORTANT NOTE: This option will clear ALL votes for ALL postings. This will also clear ALL data in the MoodThingy Stats page. Use this if you were testing MoodThingy for yourself and now want to accept real data. If you're unsure about resetting your data, <a target="_blank" href="http://codex.wordpress.org/Backing_Up_Your_Database">make sure you back up your WordPress database</a> - once you clear the data, there's no way to undo this.</p>
							
							<p><strong>To clear all data, type DELETE in all Caps the textbox above and click on "Save Changes".</strong></p>
							
							</td>
						</tr>
					</tbody>
				</table>
				
				
					<input type="hidden" id="validkey" name="validkey" value="<?php echo $options['validkey']; ?>">
					<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">
			
					<p class="submit">
					<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
					</p>
				<!-- /form -->	
			</div>
			<div class="content" id="customize">
				<h3></h3>
				<img src="<?php echo MOODTHINGY_PLUGIN_DIR . '/moodthingy-cusomization.jpg'; ?>" style="float:right; border:5px solid #eee; margin-left:20px; width:300px;">
				<p><big>The ability to customize colors and moods on MoodThingy is available by <a href="http://codecanyon.net/item/moodthingy-mood-rating-widget-for-wordpress-pro/2255966" target="_blank">purchasing the MoodThingy Mood Rating Widget for WordPress PRO plug-in on CodeCanyon</a>.</big></p> 
				
				<p>You can easily remove the MoodThingy logo in the PRO version as well. Support for the PRO version of MoodThingy helps keeps us developing both the free and the Pro versions!</p>
								
				<h3 style="clear:both;">Additional CSS Box</h3>

				<div id="csswrapper">
					<textarea style="width:100%;" rows="10" id="cssbox" name="cssbox"><?php echo stripslashes(@file_get_contents(MOODTHINGY_CSS_FILE)); ?></textarea>		
					<p class="description">Web Developers: If you are experienced with CSS, you can override the existing MoodThingy CSS here.  It's strongly recommended that you download and <a href="http://getfirebug.com/" target="_blank">use a web development tool such as FireBug</a> before continuing</a>. The file is stored in <code>/wp-content/uploads/moodthingy-custom.css</code>.</p>
					
					<p class="description">Uncomfortable with CSS?  If you're just looking to change the colors, <a href="http://codecanyon.net/item/moodthingy-mood-rating-widget-for-wordpress-pro/2255966" target="_blank">consider purchasing the PRO version</a>!</p>
				</div>

				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">Bypass Plugin CSS</th>
							<td><input type="checkbox" name="bypasscss" <?php if ( $options["bypasscss"]=='on' ) { echo 'checked="true"'; } ?>>
							<p class="description">Bypass the default and custom CSS used in the MoodThingy plug-in and use CSS from your theme instead. This may be necessary for specific WordPress Multisite installations. For advanced users only.</p></td>
						</tr>									
					</tbody>
				</table>	

				<p class="submit">
				<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
				</p>					
				
			</div>	
			<div class="content" id="faq">
				<h3>Does the MoodThingy plug-in include widgets?</h3>
				<p>If your WordPress theme uses widgets, a MoodThingy Widget is available in the Widgets menu which can list the most voted on posts.</p>
				
				<h3>How do I install MoodThingy into my Wordpress templates?</h3>
				<p>If the "Automatically display the MoodThingy widget at the end of each blog post" checkbox is checked, the MoodThingy widget will automatically display on an individual post, right after the comment.</p>
				<p>Otherwise, you can use the WordPress shortcode [moodthingy] to have your MoodThingy widget display.</p>
				<p>If you're gangsta and feel comfortable with PHP and Wordpress templates, you can add the widget anywhere you feel like, by disabling the "Automatically display the MoodThingy widget at the end of each blog post" checkbox add the following bit of code in your Wordpress individual template:</p>
				<code>&lt;?php if ( function_exists('print_moodthingy_widget') ) { print_moodthingy_widget(); } ?&gt;</code>
				<p>On the default TwentyTen Wordpress theme, you should put this on your comment template (comments.php) This will automatically display the widget before your blog post comments. That's it!</p>
			</div>
		</div>
		
		</form>
	
	</div>
	<?php 
}

function moodthingy_reset_moods() {
	global $wpdb;
	
	$table_name = $wpdb->prefix.'lydl_posts';
	$table_name2 = $wpdb->prefix.'lydl_poststimestamp';	

	$wpdb->query( "DELETE FROM ".$table_name );
	$wpdb->query( "DELETE FROM ".$table_name2 );
	echo '<div class="updated"><p><strong>All Moods have been reset.</strong></p></div>';
}

function moodthingy_dashboard_page() {
	global $wpdb;
	global $moods;
	
	$hidden_field_name = 'moodthingy_submit_hidden';
	$options = get_option('moodthingy_wp_options');

	// http://codex.wordpress.org/Adding_Administration_Menus
	
	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	} ?>
	<style>
	.selected { font-weight:bold; color:#000; text-decoration: none; }
	.totaltable,.mood_table { display:none; }
	#daily,#mood_1 { display:block; }
	#apikey, #apiname { padding: 5px; width: 200px; }
	</style>
	<script type="text/javascript">
	jQuery(document).ready(function(){
		jQuery("#tabs a").click(function(){
			var activeTab = jQuery(this).attr("rel");
			jQuery(this).addClass("button-primary").removeClass("button-secondary").siblings().addClass("button-secondary").removeClass("button-primary");
			jQuery(".mood_table:visible").fadeOut("fast", function(){
				jQuery("#"+activeTab).slideDown("fast");
			});
			
			return false;
		});
		jQuery("#tabs2 a").click(function(){
			var activeTab = jQuery(this).attr("rel");
			jQuery(this).addClass("button-primary").removeClass("button-secondary").siblings().addClass("button-secondary").removeClass("button-primary");
			jQuery(".totaltable:visible").fadeOut("fast", function(){
				jQuery("#"+activeTab).slideDown("fast");
			});
			
			return false;
		});
				
	});	
	</script>
	<?php 
		moodthingy_printmoodtables(); 
}

function moodthingy_printmoodtables() {
	global $wpdb;
	global $moods; ?>
	
	<div class="wrap">
			<h2 class="nav-tab-wrapper">
			MoodThingy
			
			<a class="nav-tab nav-tab-active" href="<?php echo admin_url('index.php?page=moodthingy'); ?>">Stats</a>
			<a class="nav-tab" rel="settings" href="<?php echo admin_url('options-general.php?page=moodthingy#settings'); ?>">Settings</a>
			<a class="nav-tab" rel="customize" href="<?php echo admin_url('options-general.php?page=moodthingy#customize'); ?>">Customization</a>
			<a class="nav-tab" rel="faq" href="<?php echo admin_url('options-general.php?page=moodthingy#faq'); ?>">FAQ</a>
		</h2>
	
	<h3>Total Most Voted On Posts By Mood</h3>
	<p>To get an accurate read of the posts people care about, we're only counting posts that have more than one vote.</p>
	<div id="tabs">
		<?php for ($i=1; $i<=6; $i=$i+1) { ?>
		<a href="#" class="<?php if ($i==1) echo 'button-primary'; else echo 'button-secondary'; ?>" rel="mood_<?php echo $i; ?>">Most <?php echo $moods[$i]; ?></a> 
		<?php } ?>
	</div>
	
	<?php	
	for ($i=1; $i<=6; $i=$i+1) {
		$objs = $wpdb->get_results("SELECT ID, emotion_" . $i . " as emoted, 
		(emotion_1 + emotion_2 + emotion_3 + emotion_4 + emotion_5 + emotion_6
		) AS total, (
		  emotion_" . $i . " / (
		  SELECT CASE WHEN total=0
		  THEN 0.1
		  ELSE total
		  END 
		) *100
		) AS ranking, (
		  emotion_" . $i . " / (
		  SELECT CASE WHEN total=0
		  THEN 0.1
		  ELSE total
		  END 
		) * (emotion_" . $i . ")
		) AS weighted
		FROM {$wpdb->prefix}lydl_posts WHERE (emotion_" . $i . ">0 AND emotion_1 + emotion_2 + emotion_3 + emotion_4 + emotion_5 + emotion_6>1) 
		ORDER BY weighted DESC , ranking DESC , total DESC LIMIT 10");
		
		echo '<div class="mood_table" id="mood_' . $i . '">';
		echo '<h4>Most ' . $moods[$i] . '</h4><table class="widefat">';
		echo '<thead><tr><th>Blog post</th><th>Votes</th><th>Total</th><th>Percentage</th><th>Weighted Score</th></tr></thead>';
		if (sizeof($objs) > 0) {
			foreach ($objs as $obj) {
				echo '<tr>';
				echo '<td><a href="' . get_permalink($obj->ID) . '">' . get_the_title($obj->ID) . '</a></td>';
				echo '<td>' . $obj->emoted . '</td>';
				echo '<td>' . $obj->total . '</td>';
				echo '<td>' . $obj->ranking . '%</td>';
				echo '<td>' . $obj->weighted . '</td>';
				echo '</tr>';
			}
		} else {
			echo '<tr><td colspan="3">No one has voted for this yet. Check back soon.</td></tr>';
		}
		echo '</table>';
		echo '</div>';
	} ?>
	
<h3>Most Voted On Posts By Date</h3>
	<div id="tabs2">
		<a href="#" class="button-secondary" rel="totalvotes">Most Voted</a>
		<a href="#" class="button-secondary" rel="monthly">Most Voted in the Past Month</a>
		<a href="#" class="button-secondary" rel="weekly">Most Voted in the Past Week</a>
		<a href="#" class="button-primary" rel="daily">Most Voted in the Past Day</a>
	</div>

<?php

$objs = $wpdb->get_results("SELECT post_ID, (SUM(emotion_1)) as emotion_1,  (SUM(emotion_2)) as emotion_2, (SUM(emotion_3)) as emotion_3, (SUM(emotion_4)) as emotion_4, (sum(emotion_5)) as emotion_5, (sum(emotion_6)) as emotion_6, ((SUM(emotion_1)) + (SUM(emotion_2)) + (SUM(emotion_3)) + (SUM(emotion_4)) + (SUM(emotion_5)) + (SUM(emotion_6))) AS total FROM (
SELECT post_ID, SUM(votes) AS emotion_1, 0 as emotion_2, 0 as emotion_3, 0 as emotion_4, 0 as emotion_5, 0 as emotion_6 FROM {$wpdb->prefix}lydl_poststimestamp WHERE emotion=1 group by post_ID
UNION
SELECT post_ID, 0, SUM(votes) AS emotion_2, 0, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=2 group by post_ID
UNION
SELECT post_ID, 0, 0, SUM(votes) AS emotion_3, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=3 group by post_ID
UNION
SELECT post_ID, 0, 0, 0, SUM(votes) AS emotion_4, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=4 group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, SUM(votes) AS emotion_5, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=5 group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, 0, SUM(votes) AS emotion_6 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=6 group by post_ID
) as test GROUP BY post_ID ORDER BY total desc LIMIT 10");
	echo '<div class="totaltable" id="totalvotes"><h4>Most Voted</h4><table class="widefat">';
	echo '<thead><tr><th>Blog post</th><th>'. $moods[1] .'</th><th>'. $moods[2] .'</th><th>'. $moods[3] .'</th><th>'. $moods[4] .'</th><th>'. $moods[5] .'</th><th>'. $moods[6] .'</th></tr></thead>';
	if (sizeof($objs) > 0) {
		foreach ($objs as $obj) {
			echo '<tr>';
			echo '<td><a href="' . get_permalink($obj->post_ID) . '">' . get_the_title($obj->post_ID) . '</a></td>';
			echo '<td>' . $obj->emotion_1 . '</td>';
			echo '<td>' . $obj->emotion_2 . '</td>';
			echo '<td>' . $obj->emotion_3 . '</td>';
			echo '<td>' . $obj->emotion_4 . '</td>';									
			echo '<td>' . $obj->emotion_5 . '</td>';
			echo '<td>' . $obj->emotion_6 . '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr><td colspan="3">No one has voted for this yet. Check back soon.</td></tr>';
	}
	echo '</table></div>';

$objs = $wpdb->get_results("SELECT post_ID, (SUM(emotion_1)) as emotion_1,  (SUM(emotion_2)) as emotion_2, (SUM(emotion_3)) as emotion_3, (SUM(emotion_4)) as emotion_4, (sum(emotion_5)) as emotion_5, (sum(emotion_6)) as emotion_6, ((SUM(emotion_1)) + (SUM(emotion_2)) + (SUM(emotion_3)) + (SUM(emotion_4)) + (SUM(emotion_5)) + (SUM(emotion_6))) AS total FROM (
SELECT post_ID, SUM(votes) AS emotion_1, 0 as emotion_2, 0 as emotion_3, 0 as emotion_4, 0 as emotion_5, 0 as emotion_6 FROM {$wpdb->prefix}lydl_poststimestamp WHERE emotion=1 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, SUM(votes) AS emotion_2, 0, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=2 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, SUM(votes) AS emotion_3, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=3 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, SUM(votes) AS emotion_4, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=4 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, SUM(votes) AS emotion_5, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=5 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, 0, SUM(votes) AS emotion_6 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=6 AND (day + INTERVAL 30 DAY) >= NOW() group by post_ID
) as test group by post_ID ORDER BY total desc LIMIT 10");
	echo '<div class="totaltable" id="monthly"><h4>Most Voted in the Past Month</h4><table class="widefat">';
	echo '<thead><tr><th>Blog post</th><th>'. $moods[1] .'</th><th>'. $moods[2] .'</th><th>'. $moods[3] .'</th><th>'. $moods[4] .'</th><th>'. $moods[5] .'</th><th>'. $moods[6] .'</th></tr></thead>';
	if (sizeof($objs) > 0) {
		foreach ($objs as $obj) {
			echo '<tr>';
			echo '<td><a href="' . get_permalink($obj->post_ID) . '">' . get_the_title($obj->post_ID) . '</a></td>';
			echo '<td>' . $obj->emotion_1 . '</td>';
			echo '<td>' . $obj->emotion_2 . '</td>';
			echo '<td>' . $obj->emotion_3 . '</td>';
			echo '<td>' . $obj->emotion_4 . '</td>';									
			echo '<td>' . $obj->emotion_5 . '</td>';
			echo '<td>' . $obj->emotion_6 . '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr><td colspan="3">No one has voted for this yet. Check back soon.</td></tr>';
	}
	echo '</table></div>';

$objs = $wpdb->get_results("SELECT post_ID, (SUM(emotion_1)) as emotion_1,  (SUM(emotion_2)) as emotion_2, (SUM(emotion_3)) as emotion_3, (SUM(emotion_4)) as emotion_4, (sum(emotion_5)) as emotion_5, (sum(emotion_6)) as emotion_6, ((SUM(emotion_1)) + (SUM(emotion_2)) + (SUM(emotion_3)) + (SUM(emotion_4)) + (SUM(emotion_5)) + (SUM(emotion_6))) AS total FROM (
SELECT post_ID, SUM(votes) AS emotion_1, 0 as emotion_2, 0 as emotion_3, 0 as emotion_4, 0 as emotion_5, 0 as emotion_6 FROM {$wpdb->prefix}lydl_poststimestamp WHERE emotion=1 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, SUM(votes) AS emotion_2, 0, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=2 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, SUM(votes) AS emotion_3, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=3 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, SUM(votes) AS emotion_4, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=4 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, SUM(votes) AS emotion_5, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=5 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, 0, SUM(votes) AS emotion_6 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=6 AND (day + INTERVAL 7 DAY) >= NOW() group by post_ID
) as test group by post_ID ORDER BY total desc LIMIT 10");
	echo '<div class="totaltable" id="weekly"><h4>Most Voted in the Past Week</h4><table class="widefat">';
	echo '<thead><tr><th>Blog post</th><th>'. $moods[1] .'</th><th>'. $moods[2] .'</th><th>'. $moods[3] .'</th><th>'. $moods[4] .'</th><th>'. $moods[5] .'</th><th>'. $moods[6] .'</th</tr></thead>';
	if (sizeof($objs) > 0) {
		foreach ($objs as $obj) {
			echo '<tr>';
			echo '<td><a href="' . get_permalink($obj->post_ID) . '">' . get_the_title($obj->post_ID) . '</a></td>';
			echo '<td>' . $obj->emotion_1 . '</td>';
			echo '<td>' . $obj->emotion_2 . '</td>';
			echo '<td>' . $obj->emotion_3 . '</td>';
			echo '<td>' . $obj->emotion_4 . '</td>';									
			echo '<td>' . $obj->emotion_5 . '</td>';
			echo '<td>' . $obj->emotion_6 . '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr><td colspan="3">No one has voted for this yet. Check back soon.</td></tr>';
	}
	echo '</table></div>';

$objs = $wpdb->get_results("SELECT post_ID, (SUM(emotion_1)) as emotion_1,  (SUM(emotion_2)) as emotion_2, (SUM(emotion_3)) as emotion_3, (SUM(emotion_4)) as emotion_4, (sum(emotion_5)) as emotion_5, (sum(emotion_6)) as emotion_6, ((SUM(emotion_1)) + (SUM(emotion_2)) + (SUM(emotion_3)) + (SUM(emotion_4)) + (SUM(emotion_5)) + (SUM(emotion_6))) AS total FROM (
SELECT post_ID, SUM(votes) AS emotion_1, 0 as emotion_2, 0 as emotion_3, 0 as emotion_4, 0 as emotion_5, 0 as emotion_6 FROM {$wpdb->prefix}lydl_poststimestamp WHERE emotion=1 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, SUM(votes) AS emotion_2, 0, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=2 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, SUM(votes) AS emotion_3, 0, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=3 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, SUM(votes) AS emotion_4, 0, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=4 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, SUM(votes) AS emotion_5, 0 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=5 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
UNION
SELECT post_ID, 0, 0, 0, 0, 0, SUM(votes) AS emotion_6 from {$wpdb->prefix}lydl_poststimestamp WHERE emotion=6 AND (day + INTERVAL 1 DAY) >= NOW() group by post_ID
) as test group by post_ID ORDER BY total desc LIMIT 10");
	echo '<div class="totaltable" id="daily"><h4>Most Voted in the Past Day</h4><table class="widefat">';
	echo '<thead><tr><th>Blog post</th><th>'. $moods[1] .'</th><th>'. $moods[2] .'</th><th>'. $moods[3] .'</th><th>'. $moods[4] .'</th><th>'. $moods[5] .'</th><th>'. $moods[6] .'</th></tr></thead>';
	if (sizeof($objs) > 0) {
		foreach ($objs as $obj) {
			echo '<tr>';
			echo '<td><a href="' . get_permalink($obj->post_ID) . '">' . get_the_title($obj->post_ID) . '</a></td>';
			echo '<td>' . $obj->emotion_1 . '</td>';
			echo '<td>' . $obj->emotion_2 . '</td>';
			echo '<td>' . $obj->emotion_3 . '</td>';
			echo '<td>' . $obj->emotion_4 . '</td>';									
			echo '<td>' . $obj->emotion_5 . '</td>';
			echo '<td>' . $obj->emotion_6 . '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr><td colspan="3">No one has voted for this yet. Check back soon.</td></tr>';
	}
	echo '</table></div></div>';
}

?>
